﻿using DevExpress.ExpressApp;
using DevExpress.ExpressApp.SystemModule;
using DevExpress.Persistent.Base;
using DevExpress.Xpo;

namespace TestSecuritySolution.Module.BusinessObjects
{
    [DefaultClassOptions]
    [ListViewFilter("Current User", "[CurrentUserName] = [RegistryUserName]", true)]
    
    public class EmployeeUserTest : XPObject
    {
        public EmployeeUserTest(Session session) : base(session) { }

        //Properties for your classes
        private string _name;
        public string Name
        {
            get { return _name; }
            set { SetPropertyValue("Name", ref _name, value); }
        }

        //Specific properties
        [Persistent("CurrentUserName")]
        [VisibleInListView(false), VisibleInDetailView(false), VisibleInLookupListView(false)]
        public string CurrentUserName
        {
            get { return SecuritySystem.CurrentUserName; }
        }

        [Persistent("RegistryUserName")]
        string _registryUserName;
        [VisibleInListView(false), VisibleInDetailView(false), VisibleInLookupListView(false)]
        public string RegistryUserName
        {
            get { return _registryUserName; }
        }
        
        protected override void OnSaving()
        {
            if (SecuritySystem.CurrentUser != null)
            {
                _registryUserName = (Session.GetObjectByKey<Employee>(SecuritySystem.CurrentUserId)).UserName;
            }
            base.OnSaving();
        }
    }
}
